### Hierarchy

- Entity
  - NodeDefEntity

### Implements

- IEntity
- INodeDefEntity

## Index

### Constructors

- constructor

### Properties

- context
- entityType
- id
- invoker
- isDirty
- isNew
- propertyBag
- schema
- securityService

### Accessors

- attachedToNode
- cancelActivity
- condition
- counter
- errorCode
- errorName
- eventType
- events
- extensions
- features
- key
- lane
- mapper
- message
- name
- persist
- processDef
- script
- signal
- startContext
- startContextEntityType
- subProcessDef
- subProcessKey
- timerDefinition
- timerDefinitionType
- type

### Methods

- _extractFeatures
- _extractMapper
- calculate
- fromPojo
- getAttachedToNode
- getBoundaryEvents
- getCalculatedProperty
- getDatastoreService
- getEntityReference
- getLane
- getLaneRole
- getProcessDef
- getProperty
- getPropertyLazy
- getSubProcessDef
- initialize
- remove
- save
- secureCompare
- setCalculatedProperty
- setProperty
- toPojo

## Constructors

### constructor

- new NodeDefEntity(entityDependencyHelper: EntityDependencyHelper, context: ExecutionContext, schema: IInheritedSchema, propertyBag: IPropertyBag, entityType: IEntityType<IEntity>): NodeDefEntity

- Overrides Entity.__constructor

  - Defined in entity_types/node_def.ts:21

  #### Parameters

  - ##### entityDependencyHelper: EntityDependencyHelper

  - ##### context: ExecutionContext

  - ##### schema: IInheritedSchema

  - ##### propertyBag: IPropertyBag

  - ##### entityType: IEntityType<IEntity>

  #### Returns NodeDefEntity

## Properties

### context

context: ExecutionContext

Inherited from Entity.context

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:14

### Protected entityType

entityType: IEntityType<IEntity>

Inherited from Entity.entityType

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:17

### id

id: string

Inherited from Entity.id

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:26

### Protected invoker

invoker: IInvoker

Inherited from Entity.invoker

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:16

### isDirty

isDirty: boolean

Inherited from Entity.isDirty

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:22

### isNew

isNew: boolean

Inherited from Entity.isNew

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:21

### Protected propertyBag

propertyBag: IPropertyBag

Inherited from Entity.propertyBag

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:19

### schema

schema: IInheritedSchema

Inherited from Entity.schema

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:15

### Protected securityService

securityService: ISecurityService

Inherited from Entity.securityService

- Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:18

## Accessors

### attachedToNode

- get attachedToNode(): INodeDefEntity
- set attachedToNode(value: INodeDefEntity): void

- - Defined in entity_types/node_def.ts:98

  #### Returns INodeDefEntity

- - Defined in entity_types/node_def.ts:102

  #### Parameters

  - ##### value: INodeDefEntity

  #### Returns void

### cancelActivity

- get cancelActivity(): boolean
- set cancelActivity(value: boolean): void

- - Defined in entity_types/node_def.ts:138

  #### Returns boolean

- - Defined in entity_types/node_def.ts:142

  #### Parameters

  - ##### value: boolean

  #### Returns void

### condition

- get condition(): string
- set condition(value: string): void

- - Defined in entity_types/node_def.ts:232

  #### Returns string

- - Defined in entity_types/node_def.ts:236

  #### Parameters

  - ##### value: string

  #### Returns void

### counter

- get counter(): number
- set counter(value: number): void

- - Defined in entity_types/node_def.ts:169

  #### Returns number

- - Defined in entity_types/node_def.ts:173

  #### Parameters

  - ##### value: number

  #### Returns void

### errorCode

- get errorCode(): string
- set errorCode(value: string): void

- - Defined in entity_types/node_def.ts:250

  #### Returns string

- - Defined in entity_types/node_def.ts:254

  #### Parameters

  - ##### value: string

  #### Returns void

### errorName

- get errorName(): string
- set errorName(value: string): void

- - Defined in entity_types/node_def.ts:241

  #### Returns string

- - Defined in entity_types/node_def.ts:245

  #### Parameters

  - ##### value: string

  #### Returns void

### eventType

- get eventType(): string
- set eventType(value: string): void

- - Defined in entity_types/node_def.ts:129

  #### Returns string

- - Defined in entity_types/node_def.ts:133

  #### Parameters

  - ##### value: string

  #### Returns void

### events

- get events(): any
- set events(value: any): void

- - Defined in entity_types/node_def.ts:111

  #### Returns any

- - Defined in entity_types/node_def.ts:115

  #### Parameters

  - ##### value: any

  #### Returns void

### extensions

- get extensions(): any
- set extensions(value: any): void

- - Defined in entity_types/node_def.ts:89

  #### Returns any

- - Defined in entity_types/node_def.ts:93

  #### Parameters

  - ##### value: any

  #### Returns void

### features

- get features(): Array<IFeature>

- - Defined in entity_types/node_def.ts:258

  #### Returns Array<IFeature>

### key

- get key(): string
- set key(value: string): void

- - Defined in entity_types/node_def.ts:45

  #### Returns string

- - Defined in entity_types/node_def.ts:49

  #### Parameters

  - ##### value: string

  #### Returns void

### lane

- get lane(): ILaneEntity
- set lane(value: ILaneEntity): void

- - Defined in entity_types/node_def.ts:67

  #### Returns ILaneEntity

- - Defined in entity_types/node_def.ts:71

  #### Parameters

  - ##### value: ILaneEntity

  #### Returns void

### mapper

- get mapper(): any

- - Defined in entity_types/node_def.ts:303

  #### Returns any

### message

- get message(): string
- set message(value: string): void

- - Defined in entity_types/node_def.ts:223

  #### Returns string

- - Defined in entity_types/node_def.ts:227

  #### Parameters

  - ##### value: string

  #### Returns void

### name

- get name(): string
- set name(value: string): void

- - Defined in entity_types/node_def.ts:36

  #### Returns string

- - Defined in entity_types/node_def.ts:40

  #### Parameters

  - ##### value: string

  #### Returns void

### persist

- get persist(): boolean

- - Defined in entity_types/node_def.ts:322

  #### Returns boolean

### processDef

- get processDef(): IProcessDefEntity
- set processDef(value: IProcessDefEntity): void

- - Defined in entity_types/node_def.ts:54

  #### Returns IProcessDefEntity

- - Defined in entity_types/node_def.ts:58

  #### Parameters

  - ##### value: IProcessDefEntity

  #### Returns void

### script

- get script(): string
- set script(value: string): void

- - Defined in entity_types/node_def.ts:120

  #### Returns string

- - Defined in entity_types/node_def.ts:124

  #### Parameters

  - ##### value: string

  #### Returns void

### signal

- get signal(): string
- set signal(value: string): void

- - Defined in entity_types/node_def.ts:214

  #### Returns string

- - Defined in entity_types/node_def.ts:218

  #### Parameters

  - ##### value: string

  #### Returns void

### startContext

- get startContext(): string
- set startContext(value: string): void

- - Defined in entity_types/node_def.ts:196

  #### Returns string

- - Defined in entity_types/node_def.ts:200

  #### Parameters

  - ##### value: string

  #### Returns void

### startContextEntityType

- get startContextEntityType(): string
- set startContextEntityType(value: string): void

- - Defined in entity_types/node_def.ts:205

  #### Returns string

- - Defined in entity_types/node_def.ts:209

  #### Parameters

  - ##### value: string

  #### Returns void

### subProcessDef

- get subProcessDef(): INodeDefEntity
- set subProcessDef(value: INodeDefEntity): void

- - Defined in entity_types/node_def.ts:156

  #### Returns INodeDefEntity

- - Defined in entity_types/node_def.ts:160

  #### Parameters

  - ##### value: INodeDefEntity

  #### Returns void

### subProcessKey

- get subProcessKey(): string
- set subProcessKey(value: string): void

- - Defined in entity_types/node_def.ts:147

  #### Returns string

- - Defined in entity_types/node_def.ts:151

  #### Parameters

  - ##### value: string

  #### Returns void

### timerDefinition

- get timerDefinition(): string
- set timerDefinition(value: string): void

- - Defined in entity_types/node_def.ts:187

  #### Returns string

- - Defined in entity_types/node_def.ts:191

  #### Parameters

  - ##### value: string

  #### Returns void

### timerDefinitionType

- get timerDefinitionType(): TimerDefinitionType.date | TimerDefinitionType.duration | TimerDefinitionType.cycle
- set timerDefinitionType(value: TimerDefinitionType.date | TimerDefinitionType.duration | TimerDefinitionType.cycle): void

- - Defined in entity_types/node_def.ts:178

  #### Returns TimerDefinitionType.date | TimerDefinitionType.duration | TimerDefinitionType.cycle

- - Defined in entity_types/node_def.ts:182

  #### Parameters

  - ##### value: TimerDefinitionType.date | TimerDefinitionType.duration | TimerDefinitionType.cycle

  #### Returns void

### type

- get type(): "bpmn:UserTask" | "bpmn:ExclusiveGateway" | "bpmn:ParallelGateway" | "bpmn:ServiceTask" | "bpmn:StartEvent" | "bpmn:EndEvent" | "bpmn:IntermediateCatchEvent" | "bpmn:IntermediateThrowEvent" | "bpmn:ScriptTask" | "bpmn:BoundaryEvent" | "bpmn:CallActivity" | "bpmn:SubProcess"
- set type(value: "bpmn:UserTask" | "bpmn:ExclusiveGateway" | "bpmn:ParallelGateway" | "bpmn:ServiceTask" | "bpmn:StartEvent" | "bpmn:EndEvent" | "bpmn:IntermediateCatchEvent" | "bpmn:IntermediateThrowEvent" | "bpmn:ScriptTask" | "bpmn:BoundaryEvent" | "bpmn:CallActivity" | "bpmn:SubProcess"): void

- - Defined in entity_types/node_def.ts:80

  #### Returns "bpmn:UserTask" | "bpmn:ExclusiveGateway" | "bpmn:ParallelGateway" | "bpmn:ServiceTask" | "bpmn:StartEvent" | "bpmn:EndEvent" | "bpmn:IntermediateCatchEvent" | "bpmn:IntermediateThrowEvent" | "bpmn:ScriptTask" | "bpmn:BoundaryEvent" | "bpmn:CallActivity" | "bpmn:SubProcess"

- - Defined in entity_types/node_def.ts:84

  #### Parameters

  - ##### value: "bpmn:UserTask" | "bpmn:ExclusiveGateway" | "bpmn:ParallelGateway" | "bpmn:ServiceTask" | "bpmn:StartEvent" | "bpmn:EndEvent" | "bpmn:IntermediateCatchEvent" | "bpmn:IntermediateThrowEvent" | "bpmn:ScriptTask" | "bpmn:BoundaryEvent" | "bpmn:CallActivity" | "bpmn:SubProcess"

  #### Returns void

## Methods

### Private _extractFeatures

- _extractFeatures(): Array<IFeature>

- - Defined in entity_types/node_def.ts:282

  #### Returns Array<IFeature>

### Private _extractMapper

- _extractMapper(): any

- - Defined in entity_types/node_def.ts:307

  #### Returns any

### calculate

- calculate(context: ExecutionContext, options?: IFromPojoOptions): Promise<void>

- Inherited from Entity.calculate

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:39

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IFromPojoOptions

  #### Returns Promise<void>

### fromPojo

- fromPojo(context: ExecutionContext, data: any, options?: IFromPojoOptions): Promise<void>

- Inherited from Entity.fromPojo

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:37

  #### Parameters

  - ##### context: ExecutionContext

  - ##### data: any

  - ##### Optional options: IFromPojoOptions

  #### Returns Promise<void>

### getAttachedToNode

- getAttachedToNode(context: ExecutionContext): Promise<INodeDefEntity>

- - Defined in entity_types/node_def.ts:106

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<INodeDefEntity>

### getBoundaryEvents

- getBoundaryEvents(context: ExecutionContext): Promise<IEntityCollection<IBoundaryEventEntity>>

- - Defined in entity_types/node_def.ts:268

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<IEntityCollection<IBoundaryEventEntity>>

### getCalculatedProperty

- getCalculatedProperty(propertyThisContext: any, propertyName: string, context: ExecutionContext): Promise<any>

- Inherited from Entity.getCalculatedProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:30

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### context: ExecutionContext

  #### Returns Promise<any>

### Protected getDatastoreService

- getDatastoreService(): Promise<IDatastoreService>

- Inherited from Entity.getDatastoreService

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:20

  #### Returns Promise<IDatastoreService>

### getEntityReference

- getEntityReference(): IEntityReference

- Inherited from Entity.getEntityReference

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:56

  #### Returns IEntityReference

### getLane

- getLane(context: ExecutionContext): Promise<ILaneEntity>

- - Defined in entity_types/node_def.ts:75

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<ILaneEntity>

### getLaneRole

- getLaneRole(context: ExecutionContext): Promise<string>

- - Defined in entity_types/node_def.ts:262

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<string>

### getProcessDef

- getProcessDef(context: ExecutionContext): Promise<IProcessDefEntity>

- - Defined in entity_types/node_def.ts:62

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<IProcessDefEntity>

### getProperty

- getProperty(propertyThisContext: any, propertyName: string): any

- Inherited from Entity.getProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:27

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  #### Returns any

### getPropertyLazy

- getPropertyLazy(propertyThisContext: any, propertyName: string, context: ExecutionContext, options?: IPrivateQueryOptions): Promise<any>

- Inherited from Entity.getPropertyLazy

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:28

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### context: ExecutionContext

  - ##### Optional options: IPrivateQueryOptions

  #### Returns Promise<any>

### getSubProcessDef

- getSubProcessDef(context: ExecutionContext): Promise<INodeDefEntity>

- - Defined in entity_types/node_def.ts:164

  #### Parameters

  - ##### context: ExecutionContext

  #### Returns Promise<INodeDefEntity>

### initialize

- initialize(): Promise<void>

- Overrides Entity.initialize

  - Defined in entity_types/node_def.ts:31

  #### Returns Promise<void>

### remove

- remove(context: ExecutionContext, options?: IPrivateRemoveOptions): Promise<boolean>

- Inherited from Entity.remove

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:55

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IPrivateRemoveOptions

  #### Returns Promise<boolean>

### save

- save(context: ExecutionContext, options?: IPrivateSaveOptions): Promise<IEntity>

- Inherited from Entity.save

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:54

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IPrivateSaveOptions

  #### Returns Promise<IEntity>

### secureCompare

- secureCompare(attributeName: string, valueToCompare: string): Promise<boolean>

- Inherited from Entity.secureCompare

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:53

  #### Parameters

  - ##### attributeName: string

  - ##### valueToCompare: string

  #### Returns Promise<boolean>

### setCalculatedProperty

- setCalculatedProperty(propertyThisContext: any, propertyName: string, value: any, context: ExecutionContext): Promise<void>

- Inherited from Entity.setCalculatedProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:31

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### value: any

  - ##### context: ExecutionContext

  #### Returns Promise<void>

### setProperty

- setProperty(propertyThisContext: any, propertyName: string, value: any): void

- Inherited from Entity.setProperty

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:29

  #### Parameters

  - ##### propertyThisContext: any

  - ##### propertyName: string

  - ##### value: any

  #### Returns void

### toPojo

- toPojo(context: ExecutionContext, options?: IToPojoOptions): Promise<any>

- Inherited from Entity.toPojo

  - Defined in /var/lib/jenkins/workspace/e_execution_refactoring_poc-DKPIXNUND3CLDIYTSAAPJNCSYVHRVUQDIQUYB4OTWAJ2ACSJIXEA/node_modules/@essential-projects/data_model_contracts/dist/entity.d.ts:32

  #### Parameters

  - ##### context: ExecutionContext

  - ##### Optional options: IToPojoOptions

  #### Returns Promise<any>

Generated using TypeDoc